<?php
/**
 * Class helper for create admin offline message
 *
 * @package wp-chat-plus
 * @author InstaProduct
 * @link http://insta-product.com/
 */

if ( ! class_exists( 'IPCht_Admin_Offline' )) 
{
	class IPCht_Admin_Offline extends IPCht_Admin 
	{
		//{{ __construct

		/**
		 * Class construct
		 *
		 * @param array $config
		 * @return void
		 */
		public function __construct( $config = array() )
		{
			parent::__construct( $config );
		}

		//}}
		//{{ main

		/**
		 * Main content
		 *
		 * @return void
		 */
		public function main()
		{
			if ( isset( $_GET['action'] ) && $_GET['action'] == 'view' )
			{
				if ( empty( $_GET['id'] )) {
					wp_die( __('You attempted to edit an item that doesn&#8217;t exist. Perhaps it was deleted?', IPSWB_SLUG ) );
				}
				$id = absint( $_GET['id'] );
				$model = new IPCht_Model_ChatOffline();
				if ( ! $message = $model->getChat( $id ) ) {
					wp_die( __('You attempted to edit an item that doesn&#8217;t exist. Perhaps it was deleted?', IPSWB_SLUG ) );
				}
				//Change chat status
				$this->_setMessageStatus( $message );
				$this->message = $message;
				$this->view( 'offline/detail', 'admin' );
			}
			else
			{
				$this->view( 'offline/main', 'admin' );
			}
		}

		//}}
		//{{ _setMessageStatus

		/**
		 * Set message status
		 *
		 * @param  object $message
		 * @return void
		 */
		protected function _setMessageStatus( $message )
		{
			if ( $message->choff_status == 0 )
			{
				$toUpdate = array(
					'choff_status'		=> 1
				);

				$model = new IPCht_Model_ChatOffline();
				$model->updateChat( $message->choff_id, $toUpdate );
			}
		}

		//}}
		//{{ _setViewData

		/**
		 * Set view data
		 *
		 * @return void
		 */
		protected function _setViewData()
		{
			$this->requestID  = IPCHT_PAGENAME . '-offline';
			$this->htmlRootID = 'ipcht-admin-offline';

			//Get system config
			$model = new IPCht_Model_Setting();
			$this->systemConfig = $model->getSettings();

			//Get widget config
			$model = new IPCht_Model_Widget();
			$this->widgetConfig = $model->getSettings();
			
		}
	}
}