<?php
/**
 * Widget tab button view
 *
 * @package wp-chat-plus
 * @author InstaProduct
 * @link http://insta-product.com/
 */

$config = $this->widgetConfig;
$system = $this->systemConfig;
$label  = $config->getSetting( 'tab_label', 'Live Chat' );
$icon   = $config->getSetting( 'tab_icon', 'fa-envelope' );

$class  = 'ipcht-widget-tab';
$class .= ' ipcht-radius-' . $config->getSetting( 'tab_border_radius', 'none' );

if ( $icon == 'none' ) {
	$class .= ' ipcht-icon-none';
}

if ( $config->getSetting( 'widget_visibility', 'true' ) == 'true' ) {
  $class .= ' ipcht-open';
}
?>

<!-- start: .ipcht-widget-tab -->
<div class="<?php echo $class; ?>">
	<div class="ipcht-tab-button">
		<a href="#" class="ipcht-button">
			<span class="ipcht-button-inner">
				<?php
				if ( $icon != 'none' ) :
				?>
				<span class="ipcht-button-icon">
					<i class="ipcht-fa ipcht-<?php echo $icon; ?>"></i>
				</span>
				<?php
				endif;
				?>
				<span class="ipcht-button-label">
					<?php echo stripslashes( $label ); ?>
				</span>
			</span>
		</a>
	</div>
</div>
<!-- end .ipcht-widget-tab -->