<?php
/**
 * Class style model
 *
 * @package wp-chat-plus
 * @author InstaProduct
 * @link http://insta-product.com/
 */

if ( ! class_exists( 'IPCht_Model_Style' )) 
{
  /**
   * Class for manage post setting
   */
  class IPCht_Model_Style extends IPCht_Model
  {
    //{{ parameters

    /**
     * Take setting name
     *
     * @var string
     */
    protected $_settingName = '__ipcht_style_setting';

    //}}
    //{{ _getSettingStructure

    /**
     * Get setting structure
     *
     * @return array
     */
    protected function _getSettingStructure()
    {
      $structure = array(
        'width'                     => 'int',
        'template'                  => 'term',
        'position'                  => 'term',
        //Header
        'header_height'             => 'int',
        'header_text'               => 'title',
        'header_background_color'   => 'title',
        'header_background_image'   => 'int',
        'header_background_radius'  => 'term',
        'header_background_opacity' => 'int',
        'header_color'              => 'title',
        'header_border_color'       => 'title',
        'header_border_size'        => 'int',
        'header_border_radius'      => 'term',
        'header_font_size'          => 'int',
        'header_font_family'        => 'term',
        //Footer
        'footer_height'             => 'int',
        'footer_text'               => 'title',
        'footer_background_color'   => 'title',
        'footer_color'              => 'title',
        'footer_border_color'       => 'title',
        'footer_border_size'        => 'int',
        'footer_border_radius'      => 'term',
        'footer_font_size'          => 'int',
        'footer_font_family'        => 'term',
        //Chat Area
        'area_height'               => 'int',
        'area_background_color'     => 'title',
        'area_color'                => 'title',
        'area_border_color'         => 'title',
        'area_border_size'          => 'int',
        'area_border_radius'        => 'term',
        'area_font_size'            => 'int',
        'area_font_family'          => 'term',
        //Input Chat
        'input_height'              => 'int',
        'input_placeholder'         => 'title',
        'input_background_color'    => 'title',
        'input_color'               => 'title',
        'input_border_color'        => 'title',
        'input_border_size'         => 'int',
        'input_border_radius'       => 'term',
        'input_font_size'           => 'int',
        'input_font_family'         => 'term',
        //Chat Bubble
        'chat_background_color'     => 'title',
        'chat_color'                => 'title',
        'chat_border_color'         => 'title',
        'chat_border_size'          => 'int',
        'chat_border_radius'        => 'term',
        'chat_font_size'            => 'int',
        'chat_font_family'          => 'term',
        'chat_shadow'               => 'term',
        'chat_arrow'                => 'term',
        'chat_photo'                => 'term',
        //Effect
        'shadow'                    => 'term',
        'sending_sound'             => 'int',
        'new_chat_sound'            => 'int',
        'widget_visibility'         => 'term',
        'show_animation'            => 'term',
        'show_animation_speed'      => 'int'
      );
      return $structure;
    }
  }
}
?>
